#include "os.h"
#include "s_defines.h"
#include "match_ext.h"
#include "s_externs.h"

#ifdef RUSNET_IRCD
#include "rusnet_cmds_ext.h"

int m_codepage(cptr, sptr, parc, parv)
aClient *cptr;
aClient *sptr;
int     parc;
char    *parv[];
{
    int  i;
    FILE *fp;

    if (parc < 2) return -1;

    for (i=0; i<strlen(parv[1]); i++) parv[1][i]=toupper(parv[1][i]); 
 
    rusnet_changecodepage(sptr, parv[1], parv[0]);

    return 0;    
}

int m_force(cptr, sptr, parc, parv)
aClient *cptr;
aClient *sptr;
int     parc;
char    *parv[];
{
    aClient *acptr, *workptr = NULL, *workptr2;
    char    *pparv[3];
    int     i;
    FILE    *fp;

    if (!IsServer(cptr)) return -1;

    if (parc < 3)
	return -1;

    /* Check if parv[2] is a registered nickname */
    workptr = NULL;
    if (find_client( parv[2], workptr) != NULL)
    {
	return -1; /* Could not force nickchange, new nick is registered */
    }

    /* Check if parv[1] exists and local */

    workptr = NULL;
    if ((workptr2=find_client( parv[1], workptr)) == NULL)
    {
       return -1; /* No such user */
    }

    if (MyConnect(workptr2))
    {  
        /* Do nickchange procedure */

        pparv[0]= parv[1];
        pparv[1]= parv[2];
        pparv[2]=NULL;
        m_nick(workptr2, workptr2, 2, pparv);
    }
    else
    {
      /* Propagate FORCE to single server where $nick is registered */
      acptr = workptr2->from;
      if ((acptr != cptr) &&                     /* Split horizon */
	  (acptr->rusnet_proto >= RUSNET_1_4))	/* don't send to old servers */
	  sendto_one(acptr,"FORCE %s %s", parv[1], parv[2]);
    }
}

int m_rmode(cptr, sptr, parc, parv)
aClient *cptr,*sptr;
int     parc;
char    *parv[];
{
    aClient *acptr, *workptr = NULL, *workptr2;
    char    *pparv[4], *s;
    int     i;
    FILE    *fp;
	
    if (!IsServer(cptr)) return -1;

    if (parc < 3)
	return -1;

    /* cuted more than 4 parrameters */
    
    parv[2][4]='\0';

    /* restricted O line */

    if ( *parv[2] == '+' ) 
    	for (s = (char *) parv[2] + 1; *s != '\0'; s++) 
    		if (*s == 'o' || *s == 'O') 
    			return -1 ;

    /* Check if parv[1] exists and local */

    workptr = NULL;

    if ((workptr2=find_client( parv[1], workptr)) == NULL)
    {
       return -1; /* No such user */
    }

    if (MyConnect(workptr2))
    {  
        /* Do change mode procedure */

        pparv[0] = parv[1];
	pparv[1] = parv[1];
	pparv[2] = parv[2];
	pparv[3] = NULL;        

        /* sending to s_user.c */

	m_umode(NULL, workptr2, 3, pparv); /*internal fake call again*/

    }
    else
    {
      acptr = workptr2->from;
      if ((acptr != cptr) &&                     /* Split horizon */
	  (acptr->rusnet_proto >= RUSNET_1_4_2))   /* don't send to old servers */
	  sendto_one(acptr,"RMODE %s %s", parv[1], parv[2]);
    }

}

int m_rcpage(cptr, sptr, parc, parv)
aClient *cptr,*sptr;
int     parc;
char    *parv[];
{
    aClient *acptr, *workptr = NULL, *workptr2;
    char    *pparv[3];
    int     i;
    FILE    *fp;

    if (!IsServer(cptr)) return -1;

    if (parc < 3)
	return -1;

    /* Check if parv[1] exists and local */

    workptr = NULL;

    if ((workptr2=find_client( parv[1], workptr)) == NULL)
    {
       return -1; /* No such user */
    }

    if (MyConnect(workptr2))
    {  
        /* Do change mode procedure */

        pparv[0] = parv[1];
	pparv[1] = parv[2];
	m_codepage(NULL, workptr2, 2, pparv);
    }
    else
    {
      acptr = workptr2->from;
      if ((acptr != cptr) &&                     /* Split horizon */
	  (acptr->rusnet_proto >= RUSNET_1_4_2))   /* don't send to old servers */
	  sendto_one(acptr,"RCPAGE %s %s", parv[1], parv[2]);
    }
}
#endif
